<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		recommend
 */

class Hook_addon_registry_recommend
{
	/**
	 * Get a list of file permissions to set
	 *
	 * @return array			File permissions to set
	 */
	function get_chmod_array()
	{
		return array();
	}

	/**
	 * Get the version of ocPortal this addon is for
	 *
	 * @return float			Version number
	 */
	function get_version()
	{
		return ocp_version_number();
	}

	/**
	 * Get the description of the addon
	 *
	 * @return string			Description of the addon
	 */
	function get_description()
	{
		return 'Allow members to easily recommend the website to others.';
	}

	/**
	 * Get a mapping of dependency types
	 *
	 * @return array			File permissions to set
	 */
	function get_dependencies()
	{
		return array(
			'requires'=>array(),
			'recommends'=>array(),
			'conflicts_with'=>array()
		);
	}

	/**
	 * Get a list of files that belong to this addon
	 *
	 * @return array			List of files
	 */
	function get_file_list()
	{
		return array(
			'sources/hooks/systems/config_default/points_RECOMMEND_SITE.php',
			'sources/hooks/systems/realtime_rain/recommend.php',
			'sources/hooks/systems/addon_registry/recommend.php',
			'themes/default/images/menu_items/community_navigation/recommend.png',
			'lang/EN/recommend.ini',
			'pages/modules/recommend.php',
			'pages/comcode/EN/recommend_help.txt',
			'sources/recommend.php',
			'themes/default/images/recommend/facebook.gif',
			'themes/default/images/recommend/twitter.gif',
			'themes/default/images/recommend/stumbleupon.gif',
			'themes/default/images/recommend/digg.gif',
			'themes/default/images/recommend/favorites.gif',
			'themes/default/images/recommend/index.html',
			'themes/default/images/recommend/print.gif',
			'themes/default/images/recommend/recommend.gif',
			'sources/blocks/main_screen_actions.php',
			'screen_actions.css',
			'BLOCK_MAIN_SCREEN_ACTIONS.tpl'
		);
	}


	/**
	 * Get mapping between template names and the method of this class that can render a preview of them
	 *
	 * @return array						The mapping
	 */
	function tpl_previews()
	{
		return array(
			'BLOCK_MAIN_SCREEN_ACTIONS.tpl'=>'block_main_screen_actions'
		);
	}

	/**
	 * Get a preview(s) of a (group of) template(s), as a full standalone piece of HTML in Tempcode format.
	 * Uses sources/lorem.php functions to place appropriate stock-text. Should not hard-code things, as the code is intended to be declaritive.
	 * Assumptions: You can assume all Lang/CSS/Javascript files in this addon have been pre-required.
	 *
	 * @return array						Array of previews, each is Tempcode. Normally we have just one preview, but occasionally it is good to test templates are flexible (e.g. if they use IF_EMPTY, we can test with and without blank data).
	 */
	function tpl_preview__block_main_screen_actions()
	{
		return array(
			lorem_globalise(do_lorem_template('BLOCK_MAIN_SCREEN_ACTIONS', array(
				'PRINT_URL'=>placeholder_url(),
				'RECOMMEND_URL'=>placeholder_url(),
				'EASY_SELF_URL'=>placeholder_url(),
				'TITLE'=>lorem_phrase()
			)), NULL, '', true)
		);
	}
}
